if not PriorityQueue then return end

if select(2, UnitClass('player')) ~= "SHAMAN" then
	return
end

local L = LibStub("AceLocale-3.0"):GetLocale("PriorityQueue")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = PriorityQueue.constants -- Defined in PriorityQueue LUA no locale needed.

C["Stormstrike"], _, C["Stormstrike Icon"] = GetSpellInfo(32176)
C["Windfury Attack"], _, C["Windfury Attack Icon"] = GetSpellInfo(25584)
C["Frost Shock"], _, C["Frost Shock Icon"] = GetSpellInfo(49236)
C["Earth Shock"], _, C["Earth Shock Icon"] = GetSpellInfo(49231)
C["Flame Shock"], _, C["Flame Shock Icon"] = GetSpellInfo(49233)
C["Wind Shock"], _, C["Wind Shock Icon"] = GetSpellInfo(57994)
C["Lava Lash"], _, C["Lava Lash Icon"] = GetSpellInfo(60103)
C["Maelstrom Weapon"], _, C["Maelstrom Weapon Icon"] = GetSpellInfo(51532)
C["Water Shield"], _, C["Water Shield Icon"] = GetSpellInfo(33736)
C["Lightning Shield"], _, C["Lightning Shield Icon"] = GetSpellInfo(49281)
C["Earth Shield"], _, C["Earth Shield Icon"] = GetSpellInfo(49284)
C["Elemental Devastation"], _, C["Elemental Devastation Icon"] = GetSpellInfo(29178)
C["Flurry"], _, C["Flurry Icon"] = GetSpellInfo(16284)
if PriorityQueue.patch31 then
	C["Unleashed Rage"], _, C["Unleashed Rage Icon"] = GetSpellInfo(30809)
else
	C["Unleashed Rage"], _, C["Unleashed Rage Icon"] = GetSpellInfo(30807)
end
C["Windfury Weapon"], _, C["Windfury Weapon Icon"] = GetSpellInfo(58804)
C["Flametongue Weapon"], _, C["Flametongue Weapon Icon"] = GetSpellInfo(58790)
C["Frostbrand Weapon"], _, C["Frostbrand Weapon Icon"] = GetSpellInfo(58796)
C["Earthliving Weapon"], _, C["Earthliving Weapon Icon"] = GetSpellInfo(51994)
C["Lightning Bolt"], _, C["Lightning Bolt Icon"] = GetSpellInfo(49238)
C["Chain Lightning"], _, C["Chain Lightning Icon"] = GetSpellInfo(49271)
C["Heroic Presence"], _, C["Heroic Presence Icon"] = GetSpellInfo(28878)
C["Shamanistic Rage"], _, C["Shamanistic Rage Icon"] = GetSpellInfo(30823)
C["Feral Spirit"], _, C["Feral Spirit Icon"] = GetSpellInfo(51533)
C["Healing Wave"], _, C["Healing Wave Icon"] = GetSpellInfo(49273)
C["Chain Heal"], _, C["Chain Heal Icon"] = GetSpellInfo(55459)
C["Searing Totem"], _, C["Searing Totem Icon"] = GetSpellInfo(58704)
C["Magma Totem"], _, C["Magma Totem Icon"] = GetSpellInfo(58734)

---------------------------
-- Shaman Priorities
---------------------------

PriorityQueue.priorityTable.name["mw5_lb"] = L["MW5 Lightning Bolt"]
PriorityQueue.priorityTable.icon["mw5_lb"] = C["Lightning Bolt Icon"]
PriorityQueue.priorityTable.test["mw5_lb"] = 
	function () 
		return PriorityQueue.db.char.msstacks == 5 
	end 

PriorityQueue.priorityTable.name["mw4_lb"] = L["MW4 Lightning Bolt"]
PriorityQueue.priorityTable.icon["mw4_lb"] = C["Lightning Bolt Icon"]
PriorityQueue.priorityTable.test["mw4_lb"] = 
	function () 
		return PriorityQueue.db.char.msstacks >= 4 
	end 

PriorityQueue.priorityTable.name["mw5_cl"] = L["MW5 Chain Lightning"]
PriorityQueue.priorityTable.icon["mw5_cl"] = C["Chain Lightning Icon"]
PriorityQueue.priorityTable.test["mw5_cl"] = 
	function () 
		local start, duration = GetSpellCooldown(C["Chain Lightning"])
		if start then
			local timeleft = start + duration - GetTime()
			return PriorityQueue.db.char.msstacks == 5 and timeleft <= PriorityQueue.db.char.priority.cooldown 
		else
			return false
		end
	end 

PriorityQueue.priorityTable.name["mw4_cl"] = L["MW4 Chain Lightning"]
PriorityQueue.priorityTable.icon["mw4_cl"] = C["Chain Lightning Icon"]
PriorityQueue.priorityTable.test["mw4_cl"] = 
	function () 
		local start, duration = GetSpellCooldown(C["Chain Lightning"])
		if start then
			local timeleft = start + duration - GetTime()
			return PriorityQueue.db.char.msstacks >= 4 and timeleft <= PriorityQueue.db.char.priority.cooldown 
		else
			return false
		end
	end 

PriorityQueue.priorityTable.name["ss"] = C["Stormstrike"]
PriorityQueue.priorityTable.icon["ss"] = C["Stormstrike Icon"]
PriorityQueue.priorityTable.test["ss"] =  
	function () 
		local start, duration = GetSpellCooldown(C["Stormstrike"])
		if start then
			local timeleft = start + duration - GetTime()
			return timeleft <= PriorityQueue.db.char.priority.cooldown
		else
			return false
		end
	end 

PriorityQueue.priorityTable.name["es"] = C["Earth Shock"]
PriorityQueue.priorityTable.icon["es"] = C["Earth Shock Icon"]
PriorityQueue.priorityTable.test["es"] =  
	function () 
		local start, duration = GetSpellCooldown(C["Earth Shock"])
		if start then
			local timeleft = start + duration - GetTime()
			return timeleft <= PriorityQueue.db.char.priority.cooldown 
		else
			return false
		end
	end 

PriorityQueue.priorityTable.name["es_ss"] = L["Earth Shock if SS"]
PriorityQueue.priorityTable.icon["es_ss"] = C["Earth Shock Icon"]
PriorityQueue.priorityTable.test["es_ss"] =  
	function () 
		local ssdebuff, duration = PriorityQueue:GetStormStrikeInfo()
		if ssdebuff and duration > PriorityQueue.db.char.priority.cooldown then
			local start, duration = GetSpellCooldown(C["Earth Shock"])
			if start then
				local timeleft = start + duration - GetTime()
				return timeleft <= PriorityQueue.db.char.priority.cooldown 
			end
		end
		return false
	end 

PriorityQueue.priorityTable.name["fs"] = C["Flame Shock"]
PriorityQueue.priorityTable.icon["fs"] = C["Flame Shock Icon"]
PriorityQueue.priorityTable.test["fs"] =  
	function () 
		local start, duration = GetSpellCooldown(C["Flame Shock"])
		if start then
			local timeleft = start + duration - GetTime()
			local _, debufftime = PriorityQueue:GetFlameShockInfo()
			return timeleft <= PriorityQueue.db.char.priority.cooldown and debufftime <= PriorityQueue.db.char.priority.fstimeleft
		else
			return false
		end
	end 
	
PriorityQueue.priorityTable.name["ll"] = C["Lava Lash"]
PriorityQueue.priorityTable.icon["ll"] = C["Lava Lash Icon"]
PriorityQueue.priorityTable.test["ll"] =  
	function () 
		local start, duration = GetSpellCooldown(C["Lava Lash"])
		if start then
			local timeleft = start + duration - GetTime()
			return timeleft <= PriorityQueue.db.char.priority.cooldown 
		else
			return false
		end
	end 
	
PriorityQueue.priorityTable.name["st"] = C["Searing Totem"]
PriorityQueue.priorityTable.icon["st"] = C["Searing Totem Icon"]
PriorityQueue.priorityTable.test["st"] =  
	function () 
		if PriorityQueue:GetGCD(C["Lightning Shield"]) <= PriorityQueue.db.char.priority.cooldown then
			-- only bother checking for totem availabilty if we have a GCD
			local _, totemname, start, duration = GetTotemInfo(1)
			if not totemname or totemname == "" then -- no fire totem deployed so recommend it be dropped
				return true
			end
			if start and strmatch(totemname, C["Searing Totem"]) then
				local timeleft = start + duration - GetTime()
				return timeleft <= PriorityQueue.db.char.priority.cooldown 
			end
		end
		return false
	end 

PriorityQueue.priorityTable.name["mt"] = C["Magma Totem"]
PriorityQueue.priorityTable.icon["mt"] = C["Magma Totem Icon"]
PriorityQueue.priorityTable.test["mt"] =  
	function () 
		if PriorityQueue:GetGCD(C["Lightning Shield"]) <= PriorityQueue.db.char.priority.cooldown then
			-- only bother checking for totem availabilty if we have a GCD
			local _, totemname, start, duration = GetTotemInfo(1)
			if not totemname or totemname == "" then -- no fire totem deployed so recommend it be dropped
				return true
			end
			if start and strmatch(totemname, C["Magma Totem"]) then
				local timeleft = start + duration - GetTime()
				return timeleft <= PriorityQueue.db.char.priority.cooldown 
			end
		end
		return false
	end 

PriorityQueue.priorityTable.name["mw5_hw"] = L["MW5 Healing Wave"]
PriorityQueue.priorityTable.test["mw5_hw"] = 
	function () 
		if PriorityQueue.db.char.priority.chingroup == true and GetNumPartyMembers() > 0 then
			PriorityQueue.priorityTable.icon["mw5_hw"] = C["Chain Heal Icon"]
		else
			PriorityQueue.priorityTable.icon["mw5_hw"] = C["Healing Wave Icon"]
		end
		local healthpercent = 100 * UnitHealth("player") / UnitHealthMax("player")
		return PriorityQueue.db.char.msstacks == 5 and healthpercent <= PriorityQueue.db.char.priority.hwhealth
	end
	
PriorityQueue.priorityTable.name["mw4_hw"] = L["MW5 Healing Wave"]
PriorityQueue.priorityTable.test["mw4_hw"] = 
	function () 
		if PriorityQueue.db.char.priority.chingroup == true and GetNumPartyMembers() > 0 then
			PriorityQueue.priorityTable.icon["mw4_hw"] = C["Chain Heal Icon"]
		else
			PriorityQueue.priorityTable.icon["mw4_hw"] = C["Healing Wave Icon"]
		end
		local healthpercent = 100 * UnitHealth("player") / UnitHealthMax("player")
		return PriorityQueue.db.char.msstacks >= 4 and healthpercent <= PriorityQueue.db.char.priority.hwhealth
	end
	
PriorityQueue.priorityTable.name["shield"] = C["Water Shield"] .. "/" .. C["Lightning Shield"]
PriorityQueue.priorityTable.test["shield"] = 
	function ()
		local orbs, shield, shieldExpires = PriorityQueue:GetShieldInfo()
		local timeleft = shieldExpires - GetTime()
		if timeleft <= PriorityQueue.db.char.priority.cooldown or orbs <= PriorityQueue.db.char.priority.shieldorbs then
			local manapercent = 100 * UnitMana("player") / UnitManaMax("player")
			if manapercent <= PriorityQueue.db.char.priority.wsmana then
				PriorityQueue.priorityTable.icon["shield"] = C["Water Shield Icon"]
				return true
			else
				PriorityQueue.priorityTable.icon["shield"] = C["Lightning Shield Icon"]
				return true
			end
		else
			return false
		end 
	end

PriorityQueue.priorityTable.name["none"] = L["None"]
_, _, PriorityQueue.priorityTable.icon["none"] = "Interface/Tooltips/UI-Tooltip-Background"
PriorityQueue.priorityTable.test["none"] = function () return false end 

----------------------
-- Buff functions --
----------------------
	
function PriorityQueue:GetShieldInfo()
	local index = 1
	ShieldTime = 0
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, shieldExpires = UnitBuff("PLAYER", index)
		ShieldTime = shieldExpires
		if self:SetShieldType(name) then
			return count, name, shieldExpires
		end
		index = index + 1
	end
	return 0, "", 0
end

function PriorityQueue:GetFlameShockInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, shockExpires, isMine = UnitDebuff("target", index)
		if name == C["Flame Shock"] and isMine then -- don't return true on finding another player's FS
			return true, shockExpires - GetTime()
		end
		index = index + 1
	end
	return false, 0
end

function PriorityQueue:GetStormStrikeInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, isMine = UnitDebuff("target", index)
		if name == C["Stormstrike"] and isMine then -- don't return true on finding another player's FS
			return true, debuffExpires - GetTime()
		end
		index = index + 1
	end
	return false, 0
end

function PriorityQueue:GetMaelstromInfo()
	local index = 1
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, maelstromTime = UnitBuff("PLAYER", index)
		if name == C["Maelstrom Weapon"] then
			return count, maelstromTime
		end
		index = index + 1
	end
	return 0, 0 
end

function PriorityQueue:CheckWindShock()
	if not self.db.char.priority.worldbossonly or (self.db.char.priority.worldbossonly and UnitClassification("target") == "worldboss") then
		if self.db.char.windshockshow and (GetNumPartyMembers()>=4 or GetNumRaidMembers()>=4) then
			-- don't use windshock option if soloing
			local _, state, _, raw = UnitDetailedThreatSituation("player", "target")
			-- state 2 or 3 = tanking which is not what an Enh Shammy should be doing
			-- state 0 threat < 100%, state 1 threat >=100%
			if not state then state = 0 end
			if not raw then raw = 0 end
			if  state > 1 or raw > self.db.char.threatThreshold then
				-- we have exceeded threshold or have already started tanking so wind shock needed.
				local startTime, duration = GetSpellCooldown(C["Wind Shock"])
				if startTime then -- extra check in case player hasn't learned Wind Shock
					local timeleft = startTime + duration - GetTime()
					if timeleft <= PriorityQueue.db.char.priority.cooldown then -- check its off cooldown
						return true
					end
				end
			end
		end
	end
	return false
end

function PriorityQueue:CheckShamanisticRage()
	local srtalent
	if self.patch31 then
		_, _, _, _, srtalent = GetTalentInfo(2,26)
	else
		_, _, _, _, srtalent = GetTalentInfo(2,25)
	end
	if srtalent == 1 then
		local startTime, duration = GetSpellCooldown(C["Shamanistic Rage"])
		if startTime then 
			local timeleft = startTime + duration - GetTime()
			local manapercent = 100 * UnitMana("player") / UnitManaMax("player")
			if manapercent < self.db.char.priority.srmana and timeleft <= self.db.char.priority.cooldown then
				return true
			end
		end
	end
	return false
end
